#ifndef __NETIF_H__
#define __NETIF_H__
/*
 * Definitions for UDP c/s program.
 */


#ifdef _WINDOWS
#include <winsock2.h>
#else
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <arpa/inet.h>
#endif

const int MAXMESG = 8192;

class Socket {
 public:
  int			socketfd  ;
  struct sockaddr_in	serv_addr ;
};

class Network{
public:
	static Socket* sock;
	static Socket* init_connection(char* host, int port) ;
	static int    send_message(char* buf, Socket *esock) ;
	static int    receive_message(char *buf, Socket *esock) ;
	static void   close_connection(Socket *esock) ;
	static int wait_message(char *buf, Socket *esock);
};

class StringBuffer{
public:
	static char cmdbuf[MAXMESG];
	static char recvbuf[MAXMESG];
	static char saybuf[MAXMESG];
	static char msgbuf[MAXMESG];
	static char tmpbuf[MAXMESG];
	static char matbuf[MAXMESG];
	StringBuffer();
	~StringBuffer();
};

#endif //__NETIF_H__
