#ifndef __SERVERPARAM_H__
#define __SERVERPARAM_H__


#include "paramreaderutil.h"

const int SP_num_lines = 4;
const int SP_num_markers = 55;

class ServerParam
{
public:
	ServerParam();
	static option_t  OptionList[];
	///////////////////////use formal client name
	static float pitch_length;
	static float pitch_width;
	static float semi_pitch_length;
	static float semi_pitch_width;
	static float pitch_diameter;
	static float pitch_margin;
	static float penalty_area_length;
	static float penalty_area_width;
	static float goal_area_length;
	static float goal_area_width;
	static float penalty_spot_dist;
	static float corner_arc_r;
	static float free_kick_buffer;
	static float after_goal_wait;
	static float feel_distance;
	static float unum_far_length;
	static float unum_too_far_length;
	static float team_far_length;
	static float team_too_far_length;
	
	static float version;
	static int half;
	static float goal_width;
	static float player_size;
	static float player_decay;
	static float player_rand;
	static float player_weight;
	static float player_speed_max;
	static float paccel_max;
	static float stamina_max;
	static float stamina_inc;
	static float recover_init;
	static float recover_dec_thr;
	static float recover_dec;
	static float recover_min;
	static float effort_init;
	static float effort_dec_thr;
	static float effort_min;
	static float effort_dec;
	static float effort_inc_thr;
	static float effort_inc;
	static float kick_rand;
	static float team_actuator_noise;
	static float prand_factor_l;
	static float prand_factor_r;
	static float kick_rand_factor_l;
	static float kick_rand_factor_r;
	static float ball_size;
	static float ball_decay;
	static float ball_decay_ln;
	static float ball_rand;
	static float ball_weight;
	static float ball_speed_max;
	static float baccel_max;
	static float dash_power_rate;
	static float kick_power_rate;
	static float kickable_margin;
	static float kickable_area;
	static float ctl_radius;
	static float ctl_radius_width;
	static float catch_prob;
	static float catch_area_l;
	static float catch_area_w;
	static int   catch_ban_cycle;
	static int   goalie_max_moves;
	static float max_power;
	static float min_power;
	static float max_moment;
	static float min_moment;
	static float min_neck_angle;
	static float max_neck_angle;
	static float min_neck_moment;
	static float max_neck_moment;
	static float visible_angle;
	static float audio_cut_dist;
	static float dist_qstep;
	static float land_qstep;
	static float dir_qstep;
	static float dist_qstep_l;
	static float dist_qstep_r;
	static float land_qstep_l;
	static float land_qstep_r;
	static float dir_qstep_l;
	static float dir_qstep_r;
	static float disch_qstep;
	static float ckmargin;
	static float wind_dir;
	static float wind_ang;
	static float wind_force;
	static float wind_rand;
	static bool wind_none;
	static bool wind_random;
	static int   half_time;
	static int   port;
	static int   coach_port;
	static int   olcoach_port;
	static int   simulator_step;
	static int send_step;
	static int recv_step;
	static int lcm_step;
	static int say_msg_size;
	static int hear_max;
	static int hear_inc;
	static int hear_decay;
	static bool coach_mode;
	static bool coach_w_referee_mode;
	static int say_coach_cnt_max;
	static int say_coach_msg_size;
	static int send_vi_step;
	static int look_step;
	static bool use_offside;
	static bool forbid_kickoff_offside;
	//	static int verbose;
	static float offside_area;
	static float inertia_moment;
	static int sense_body_step;
	static float offside_kick_margin;
	//	static bool record_messages;
	static bool rec_log;
	static int rec_ver;
	static bool send_log;
	static int slow_down_factor;
	static bool old_hear;
	static int sv_step;
	static char host[20];
	static int drop_ball_time;
	static int start_goal_l;
	static int start_goal_r;
	static bool fullstate_l;
	static bool fullstate_r;
	
	static float midfieldline;
	static float backfieldline;
	static float left_wing;
	static float right_wing;
	
	static int clang_win_size;
	static int clang_define_win;
	static int clang_meta_win;
	static int clang_advice_win;
	static int clang_info_win;
	static int clang_mess_delay;
	static int clang_mess_per_cycle;
	
	static int player_types;
	static int subs_max;
	static float player_speed_max_delta_min;
	static float player_speed_max_delta_max;
	static float stamina_inc_max_delta_factor;
	static float player_decay_delta_min;
	static float player_decay_delta_max;
	static float inertia_moment_delta_factor;
	static float dash_power_rate_delta_min;
	static float dash_power_rate_delta_max;
	static float player_size_delta_factor;
	static float kickable_margin_delta_min;
	static float kickable_margin_delta_max;
	static float kick_rand_delta_factor;
	static float extra_stamina_delta_min;
	static float extra_stamina_delta_max;
	static float effort_max_delta_factor;
	static float effort_min_delta_factor;
	static float win_no;
	static float win_random;
	static int say_cnt_max;
	//////////////////////////////V8	use variable name
    static float slowness_on_top_for_left_team;
    static float slowness_on_top_for_right_team;
	static int portnum;
	static int coach_pnum;
	static int olcoach_pnum;
	static bool verbose;
	static char replay[];
	static bool synch_mode;
	static int synch_offset;
	static int synch_micro_sleep;
	static bool send_comms;
	static bool text_logging;
	static bool game_logging;
	static int game_log_version;
	static char text_log_dir[];
	static char game_log_dir[];
	static char text_log_fixed_name[];
	static char game_log_fixed_name[];
	static bool text_log_fixed;
	static bool game_log_fixed;
	static bool text_log_dated;
	static bool game_log_dated;
	static char log_date_format[];
	static bool log_times;
	static bool record_messages;
	static int text_log_compression;
	static int game_log_compression;
	static int profile;
	static int point_to_ban;
	static int point_to_duration;
	static int IP_reconnect;
};

#endif //__SERVERPARAM_H__





























































































