#ifndef __UNKNOWNPLAYER_H__
#define __UNKNOWNPLAYER_H__

#include "player.h"


class UnknownPlayerList;
class UnknownPlayerNode{
private:
	Player unknownplayer;
	UnknownPlayerNode* next;
public:
	UnknownPlayerNode();
	friend class UnknownPlayerList;
};

class UnknownPlayerList{
private:
	UnknownPlayerNode Head;
	UnknownPlayerNode* Tail;
	
	PlayerSide side;
public:	
	UnknownPlayerList();
	~UnknownPlayerList();
	int numplayers;
	int oldnumplayers;
	Player* List[SP_team_size];
	inline bool IsMyside(){return bool(side == Side_My);}
	inline bool IsOppside(){return bool(side == Side_Opp);}
	inline bool IsUnknownside(){return bool(side == Side_Unknown);}
	bool IsIdxValid(int idx){return idx >= 0 && idx < numplayers && List[idx] != NULL;}
	void set_side(PlayerSide playerside){side=playerside;}

	void RefreshNumPlayers(){ oldnumplayers = numplayers; }
	void Prior_update();
	void update(Time time);
	void update_end();

	void EnList(VisualUnkPlayer& player);
	void ArraySet(Player* player);
	bool Clearable(Player& player);
	int NumUnknownPlayers();
	void Set_IsControlball_FromHeard(Time time);

	void LogList(char* msg = NULL);
};

#endif //__UNKNOWNPLAYER_H__
