#ifndef __VISUALSYSTEM_H__
#define __VISUALSYSTEM_H__


#include "types.h"
#include "command.h"
#include "strategy.h"
#include "mediator.h"


const int CP_max_bvalidcycles = 10;

class MobileObject;
class Player;

class VisualSystem{
public:	
private:
/*********  direction confidence   *******************/

	AngleDeg StrategyRequestAngle[3];
	float priorityfactor[3];
	
	PrioredCommand bestaction;
	Vector nextselfpos;

	inline bool Isballbyfeel();
	inline bool Isobjconfmax(MobileObject& obj);

	void Raiseplayer(Player& p, float priority);
	void Raise(VisualObjType otype, AngleDeg angle, float priority);
	void Raise(VisualObjType otype, AngleDeg angle, AngleDeg distribute, float priority);
	void Findforgetobj(VisualObjType otype, AngleDeg angle, AngleDeg distribute, float maxpriority);

	void DoViewModeDecision(bool forcenarrow = false);
	
	void GetActionInf();

	void DoSeek(float maxpriority, AngleDeg recommendedangle = 0);
	
public:
	VisualSystem();

	void DoVisualDecision();

	
	bool Vinfo_coming;
	float Vcominginfo_angle;
	float Vcominginfo_width;

	void PredictNextSightInf();
/******************************************************************************/
	float GetPromisingAngle(VisualObjType obj, UNum idx = 0);
	inline float Predictconf(float ang);
	inline bool Predictseen(float ang);
	bool FindBall();
};

#endif //__VISUALSYSTEM_H__

































