#ifndef __WORLDMODEL_H__
#define __WORLDMODEL_H__

#include "objects.h"
#include "player.h"
#include "serverparam.h"
#include "clientparam.h"
#include "pitch.h"
#include "field.h"
#include "unknownplayer.h"
#include "strategy.h"

namespace wm  
{
	extern Ball ball;
	extern Player MyTeam[SP_team_size];
	extern Player TheirTeam[SP_team_size];
	extern MySelf Self;	

	extern Field FieldInfo;
	extern Pitch PitchInfo;
	
	extern Situation situation;
	extern Formation formation;

	//Unknown means I don't know his num.
	extern UnknownPlayerList UnknownTheirPlayerList;	
	extern UnknownPlayerList UnknownMyPlayerList;		
	extern UnknownPlayerList TeamlessPlayerList;		

	extern void InitializeObjs();

	extern Player& MyPlayer(UNum No);
	extern Player& TheirPlayer(UNum No);
	extern Player& GetPlayer(char side, UNum No);
	extern Player& GetPlayer(UNum No);

	extern PlayerType playertypes[SP_player_types];
};

using namespace wm;

#endif //__WORLDMODEL_H__
